function [eps, sig, Fc, depsvp, dFr] = epsigQ8AXpl( E, ni, Fi, c, Psi, w1, w2, w3, w4, w5, w6, w7, w8, eps0, sig0, dU0, x, y, depsvp0, dFr0 )

    %porzadkowanie wspolrzednych wezlow
    Pnts(1,1) = x(w1);
    Pnts(1,2) = y(w1);
    Pnts(2,1) = x(w2);
    Pnts(2,2) = y(w2);
    Pnts(3,1) = x(w3);
    Pnts(3,2) = y(w3);
    Pnts(4,1) = x(w4);
    Pnts(4,2) = y(w4);
    Pnts(5,1) = x(w5);
    Pnts(5,2) = y(w5);
    Pnts(6,1) = x(w6);
    Pnts(6,2) = y(w6);
    Pnts(7,1) = x(w7);
    Pnts(7,2) = y(w7);
    Pnts(8,1) = x(w8);
    Pnts(8,2) = y(w8);
    dU(1) = dU0(2.*w1-1);
    dU(2) = dU0(2.*w1);
    dU(3) = dU0(2.*w2-1);
    dU(4) = dU0(2.*w2);
    dU(5) = dU0(2.*w3-1);
    dU(6) = dU0(2.*w3);
    dU(7) = dU0(2.*w4-1);
    dU(8) = dU0(2.*w4);
    dU(9) = dU0(2.*w5-1);
    dU(10) = dU0(2.*w5);
    dU(11) = dU0(2.*w6-1);
    dU(12) = dU0(2.*w6);
    dU(13) = dU0(2.*w7-1);
    dU(14) = dU0(2.*w7);
    dU(15) = dU0(2.*w8-1);
    dU(16) = dU0(2.*w8);

    %macierz sprezystosci
    mnoznik = E ./ ((1 + ni) .* (1 - 2 .* ni));
    D = mnoznik .* [(1 - ni) ni 0 ni; ni (1 - ni) 0 ni; 0 0 ((1 - 2 .* ni)./2) 0; ni ni 0 (1 - ni)];
    dFr = dFr0;
    depsvp = depsvp0;
    %stan odksztalcenia i naprezenia
    for iG = 1:9
        %macierz B, jakobian i rzedna x pkt. Gaussa
        [B detJ r] = Q8AXmakeB( iG, Pnts );
                
        %przyrost odksztalcen calkowitych
        deps(:,iG) = B * dU';
        
        %uaktualniony stan odksztalcenia
        eps(:,iG) = eps0(:,iG) + deps(:,iG);

        %przyrost naprezen od sprezystej czesci przyrostu odksztalcen
        dsig(:,iG) = D * ( deps(:,iG) - depsvp0(:,iG) );
        
        %uaktualniony stan naprezenia
        sig(:,iG) = sig0(:,iG) + dsig(:,iG);
                                
        %kryterium plastycznosci
        Fc(iG) = Fmc( sig(:,iG), Fi .* pi ./ 180.0, c );   
        
        if Fc(iG) > 0
            %pochodna kryterium i potencjalu plastycznego
            [dFds dQds] = dFdQ( iG, sig, Fi .* pi ./ 180.0, c, Psi .* pi ./ 180.0 );                    
                    
            %predkosc odksztalcen lepkoplastycznych
            depsvpt = Fc(iG) .* dQds;
                
            %maksymalny krok czasowy
            DT = 4.*(1 + ni).*(1 - 2.*ni)./(E.*(1 - 2.*ni + sin(Fi .* pi ./ 180.0).^2));
        
            %kumulowany przyrost odksztalcen lepkoplastycznych
            depsvp(:,iG) = depsvp(:,iG) + DT .* depsvpt;
              
            %przyrost naprezen lepkoplastycznych
            dsigvp = D * ( DT .* depsvpt );
                
            %kumulowany przyrost obciazen korygujacych stan naprezenia
            GP = GaussQ8( iG );
            BDdevp = B' * dsigvp;
            dFr = dFr + detJ .* GP.w .* BDdevp .* 2 .* pi .* r;
        end
        
    end
end
